freeslot("S_PLAY_DSPING", "S_FRANK_FAVFAVFAVFAV", "sfx_favte4", "sfx_favte3", "sfx_favte2", "sfx_favte1", "sfx_shutup", "sfx_fbstrt", "S_FRANK_BREAKD", "S_FAD_FETTI", "sfx_fdpery", "sfx_fadpry", "S_PLAY_BANANA", "SPR2_CLB2", "S_PLAY_2POINT1", "S_PLAY_FRCHAIR1", "S_PLAY_FRCHAIR2", "S_PLAY_CLUBPENG2", "S_FRANK_TPOSE", "SPR2_TPOS", "SPR2_JEVL", "SPR2_CLUB", "SPR2_NATH",  "SPR2_SPKY", "S_PLAY_SPOOKDANCE", "S_PLAY_DHELP", "S_PLAY_HDANCE", "S_PLAY_CLUBPENG", "S_PLAY_JEVIL", "S_PLAY_DSPIN")
states[S_PLAY_JEVIL] = {SPR_PLAY, SPR2_JEVL, 2, nil, 0, 0, S_PLAY_JEVIL}
states[S_PLAY_DSPIN] = {SPR_PLAY, SPR2_GLID, 3, nil, 0, 0, S_PLAY_DSPIN}
states[S_PLAY_DSPING] = {SPR_PLAY, SPR2_GLID, 1, nil, 0, 0, S_PLAY_DSPING}
states[S_PLAY_CLUBPENG] = {SPR_PLAY, SPR2_CLUB|FF_ANIMATE, 183, nil, 60, 3, S_PLAY_CLUBPENG2}
states[S_PLAY_CLUBPENG2] = {SPR_PLAY, SPR2_CLB2|FF_ANIMATE, 114, nil, 37, 3, S_PLAY_CLUBPENG}
states[S_PLAY_HDANCE] = {SPR_PLAY, SPR2_CLNG, 5, nil, 0, 0, S_PLAY_HDANCE}
states[S_PLAY_DHELP] = {SPR_PLAY, SPR2_NATH, 2, nil, 0, 0, S_PLAY_DHELP}
states[S_PLAY_SPOOKDANCE] = {SPR_PLAY, SPR2_SPKY, 3, nil, 0, 0, S_PLAY_SPOOKDANCE}
states[S_FRANK_TPOSE] = {SPR_PLAY, SPR2_TPOS, 1, nil, 0, 0, S_FRANK_TPOSE}
states[S_PLAY_FRCHAIR1] = {SPR_PLAY, SPR2_MLEL|FF_ANIMATE, 27, nil, 9, 3, S_PLAY_FRCHAIR2}
states[S_PLAY_FRCHAIR2] = {SPR_PLAY, SPR2_FIRE, 1, nil, 0, 0, S_PLAY_FRCHAIR2}
states[S_PLAY_2POINT1] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_2POINT1}
states[S_PLAY_BANANA] = {SPR_PLAY, SPR2_TAL2, 4, nil, 0, 0, S_PLAY_BANANA}
states[S_FRANK_BREAKD] = {SPR_PLAY, SPR2_TAL4, 2, nil, 0, 0, S_FRANK_BREAKD}
states[S_FRANK_FAVFAVFAVFAV] = {SPR_PLAY, SPR2_TAL9, -1, nil, 0, 0, S_FRANK_FAVFAVFAVFAV}
sfxinfo[sfx_fadpry].caption = "Not gonna sugarcoat it."
sfxinfo[sfx_fbstrt].caption = "Breakdance!"
sfxinfo[sfx_shutup].caption = "Shut the hell up, just shut up."
sfxinfo[sfx_fdpery].caption = '\x8C"PAAAARRYYYY!!"\x80'

freeslot("MT_FRANK_PARRYBOX")
mobjinfo[MT_FRANK_PARRYBOX] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_FRAREFLECT_HITBOX,
	deathstate = S_NULL,
	radius = 40*FRACUNIT,
	height = 66*FRACUNIT,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
states[S_FAD_FETTI] = {SPR_FCFT, 0, -1, NULL, 0, 0, S_NULL}

local function FrankDanceHeight(p)
	if (p.mo and p.mo.valid and p.mo.skin == "frank") and p.mo.state == S_FRANK_BREAKD then return P_GetPlayerSpinHeight(p) end
end
addHook("PlayerHeight", FrankDanceHeight)
addHook("PlayerCanEnterSpinGaps", FrankDanceHeight)


addHook("PlayerSpawn", function(player)
	player.frankgroovin = false
	P_RestoreMusic(player)
	player.pflags = $1 & ~PF_FULLSTASIS
	if player.mo and player.mo.valid
	and (player.mo.state == S_FRANK_FAVFAVFAVFAV or player.mo.state == S_FRANK_BREAKD or player.mo.state == S_PLAY_FRCHAIR1 or player.mo.state == S_PLAY_FRCHAIR2 or player.mo.state == S_PLAY_CLUBPENG2 or player.mo.state == S_FRANK_TPOSE or player.mo.state == S_PLAY_JEVIL or player.mo.state == S_PLAY_DSPIN or player.mo.state == S_PLAY_CLUBPENG or player.mo.state == S_PLAY_HDANCE or player.mo.state == S_PLAY_DHELP or player.mo.state == S_PLAY_SPOOKDANCE)
		player.mo.state = S_PLAY_STND
	end
	if player.mo and player.mo.valid and player.mo.skin == "frank"	
		if player.powers[pw_carry] != CR_NIGHTSMODE then player.mo.state = S_PLAY_STND end
	end
end)

addHook("ShouldJingleContinue", function(player, musname)
	if true return end
	if musname != "FRBREK" or musname != "FRPBNJ" or musname != "_RECAT" or musname != "FRSPOK" or musname != "FRICE" or musname != "FRTWR" or musname != "FRNATH" or musname != "FRSPIN" or musname != "FRHDNC" return end
	if player and player.mo and player.mo.skin == "frank" and player.frankgroovin
		return true
	else
		return false
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.state == S_PLAY_FACEPLANT return end //cant dance when dead idot >:(
	if player.dancetoggle == 69 return end //aw man :(
	if (player.boat and player.boat.valid) return end
	if CBW_Battle and player.guard != 0 return end
	if player.mo and player.mo.valid and (player.mo.milnejoin and player.mo.milnejoin.valid) and player.dancetoggle == 3 return end //kicking quickfix
	
	if (gamemap != 1) and srb2p
		if server.P_BattleStatus and server.P_BattleStatus[player.P_party].running return end
	end

	if player.mo and player.mo.valid and player.mo.skin == "frank"	
		if player.mo.state == S_INVISIBLE return end
		if not player.frankgroovin
			player.startrandom = 0
			player.startdncsong = 0
			player.frstartdnc = 0
			player.frdncesfx = 0
			player.clubpart = 0
			player.spawnnote = 0
		end
		
		
		if player.parrytimer == nil then player.parrytimer = 0 end
		if not player.frankgroovin and player.parrytimer != 0 and P_IsObjectOnGround(player.mo)
			player.parrytimer = 0
			player.parrycooldown = TICRATE
			if CBW_Battle then player.parrycooldown = $ + 25 end
		end
		if player.parrycooldown == nil then player.parrycooldown = 0 end
		if player.spawnnote == 1 and not player.frankgroovin then player.spawnnote = 0 end
		
		//Detect when we press the key
		if not ((player.cmd.buttons & BT_TOSSFLAG and player.dancetoggle == 1) or (player.cmd.buttons & BT_CUSTOM1 and player.dancetoggle == 2) or (player.cmd.buttons & BT_CUSTOM3 and player.dancetoggle == 3))
			player.canflagpushfrank = true
			player.flagpushfrank = false
		elseif player.canflagpushfrank 
			player.flagpushfrank = true
			player.canflagpushfrank = false
		else
			player.flagpushfrank = false
		end
		if G_IsSpecialStage()
		or player.panim == PA_PAIN
		or player.panim == PA_DEAD
		or player.mo.state == S_PLAY_DEAD
			player.canflagpushfrank = false
			player.flagpushfrank = false
		end		
		
		//Parrying Pizza Tower style!!
		if player.parrytimer != 0 and player.parrycooldown < 1 and player.frankgroovin
		and not P_PlayerInPain(player)
		and player.panim != PA_DEAD
		and player.mo.state != S_PLAY_DEAD		
			if leveltime % 4 == 0 and P_IsObjectOnGround(player.mo) -- flashing
				player.mo.color = SKINCOLOR_SUPERSILVER1
				player.mo.colorized = true
			else
				player.mo.color = player.skincolor
				player.mo.colorized = false
			end
			player.parrytimer = $-1
			local hURtbox = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FRANK_PARRYBOX)
			hURtbox.target = player.mo
			hURtbox.scale = player.mo.scale
			if player.parrytimer == 1 
			or not P_IsObjectOnGround(player.mo)
				player.parrycooldown = TICRATE 
				if CBW_Battle then player.parrycooldown = $ + 25 end
				player.mo.color = player.skincolor
				player.mo.colorized = false
			end
		end
		if not P_IsObjectOnGround(player.mo) and player.parrytimer != 0 
			player.parrycooldown = TICRATE 
			if CBW_Battle then player.parrycooldown = $ + 25 end
		end
		if (player.mo.color == SKINCOLOR_SUPERSILVER1 or player.skincolor == SKINCOLOR_SUPERSILVER1) and player.mo.colorized and (player.mo.parrytimer == 0 or player.parrycooldown != 0)
			player.mo.color = player.skincolor
			player.mo.colorized = false 
		end
		
		if player.mo.color == SKINCOLOR_SUPERSILVER1 and (P_PlayerInPain(player) or player.panim == PA_DEAD)
			player.mo.color = player.skincolor
			player.mo.colorized = false
		end
		
		if player.parrycooldown != 0 -- the cooldown
			player.parrytimer = 0
			player.parrycooldown = $-1
			player.mo.colorized = false
			if player.parrycooldown == 1
				S_StartSoundAtVolume(player.mo, sfx_kc4d, 50)
				local alttrail = P_SpawnGhostMobj(player.mo)
				alttrail.color = SKINCOLOR_SUPERGOLD2
				alttrail.momx = player.mo.momx
				alttrail.momy = player.mo.momy
				alttrail.momz = player.mo.momz
				alttrail.colorized = true
				alttrail.blendmode = AST_ADD
				alttrail.destscale = $*2 
				alttrail.scalespeed = FRACUNIT/15
			end
		end

		//-----------------------------------------
		if player.mo.state == S_FRANK_BREAKD
			player.normalspeed = (skins["frank"].normalspeed)/2
		else
			if player.normalspeed == (skins["frank"].normalspeed)/2 then player.normalspeed = (skins["frank"].normalspeed) end
		end
		
		// The actual dance code
		if player.frankgroovin
			if (player.mo.state != S_FRANK_FAVFAVFAVFAV or player.mo.state != S_FRANK_BREAKD or player.mo.state != S_PLAY_2POINT1 or player.mo.state != S_PLAY_FRCHAIR1 or player.mo.state != S_PLAY_FRCHAIR2 or player.mo.state != S_PLAY_CLUBPENG2 or player.mo.state != S_FRANK_TPOSE or player.mo.state != S_PLAY_JEVIL or player.mo.state != S_PLAY_DSPIN or player.mo.state != S_PLAY_CLUBPENG or player.mo.state != S_PLAY_HDANCE or player.mo.state != S_PLAY_DHELP or player.mo.state != S_PLAY_SPOOKDANCE)
			and (player.mo.eflags & MFE_SPRUNG or player.mo.state == S_PLAY_STND)
				if player.randdance == 1
				or player.dancesel == 1
					player.mo.state = S_PLAY_JEVIL
				elseif player.randdance == 2
				or player.dancesel == 2
					player.mo.state = S_PLAY_DSPIN
				elseif player.randdance == 3 and player.clubpart == 0
				or player.dancesel == 3 and player.clubpart == 0
					player.mo.state = S_PLAY_CLUBPENG
					player.clubpart = 1
				elseif player.randdance == 4
				or player.dancesel == 4
					player.mo.state = S_PLAY_HDANCE
				elseif player.randdance == 5
				or player.dancesel == 5
					player.mo.state = S_PLAY_DHELP
				elseif player.randdance == 6
				or player.dancesel == 6
					player.mo.state = S_PLAY_SPOOKDANCE
				elseif player.dancesel == 7
					player.mo.state = S_FRANK_TPOSE
				elseif player.dancesel == 8
					player.mo.state = S_PLAY_FRCHAIR1
				elseif player.dancesel == 9 or player.dancesel == 12
					player.mo.state = S_PLAY_2POINT1
				elseif player.randdance == 7
				or player.dancesel == 10
					player.mo.state = S_FRANK_BREAKD
				elseif player.dancesel == 13
					player.mo.state = S_FRANK_FAVFAVFAVFAV
				end
			end
		
			if not (P_IsObjectOnGround(player.mo))
			or player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_SPINDASH
			or player.flagpushfrank
			or P_PlayerInPain(player)
				if (player.mo.state == S_FRANK_FAVFAVFAVFAV or player.mo.state == S_FRANK_BREAKD or player.mo.state == S_PLAY_BANANA or player.mo.state == S_PLAY_2POINT1 or player.mo.state == S_PLAY_FRCHAIR1 or player.mo.state == S_PLAY_FRCHAIR2 or player.mo.state == S_PLAY_CLUBPENG2 or player.mo.state == S_FRANK_TPOSE or player.mo.state == S_PLAY_JEVIL or player.mo.state == S_PLAY_DSPIN or player.mo.state == S_PLAY_CLUBPENG or player.mo.state == S_PLAY_HDANCE or player.mo.state == S_PLAY_DHELP or player.mo.state == S_PLAY_SPOOKDANCE)
					if player.playerstate != PST_LIVE
						player.mo.state = S_PLAY_DEAD
					else
						player.mo.state = S_PLAY_STND
					end
				end
				player.frankgroovin = false
				if not (S_MusicName(player) == "_SHOES" or S_MusicName(player) == "_INV" or S_MusicName(player) == "_MINV") then P_RestoreMusic(player) end
			else
				if (player.mo.state != S_FRANK_FAVFAVFAVFAV or player.mo.state != S_FRANK_BREAKD or player.mo.state != S_PLAY_BANANA or player.mo.state != S_PLAY_2POINT1 or player.mo.state != S_PLAY_FRCHAIR1 or player.mo.state != S_PLAY_FRCHAIR2 or player.mo.state != S_PLAY_CLUBPENG2 or player.mo.state != S_FRANK_TPOSE or player.mo.state != S_PLAY_JEVIL or player.mo.state != S_PLAY_DSPIN or player.mo.state != S_PLAY_CLUBPENG or player.mo.state != S_PLAY_HDANCE or player.mo.state != S_PLAY_DHELP or player.mo.state != S_PLAY_SPOOKDANCE)
				and not P_PlayerInPain(player)
					//RANDOMIZER
					if player.startrandom == 0
					and player.dancesel == 69
						player.randdance = P_RandomRange(1, 8)
						player.startrandom = 1
					end
					if player.dancesel != 69
						player.randdance = 0
					end
					//be able to move when breakdancing
					if not (player.dancesel == 11 or player.randdance == 8) then player.pflags = $|PF_FULLSTASIS end
					//the animation
					if player.frstartdnc == 0
						if player.randdance == 1
						or player.dancesel == 1
							player.mo.state = S_PLAY_JEVIL
						elseif player.randdance == 2
						or player.dancesel == 2
							player.mo.state = S_PLAY_DSPIN
						elseif player.randdance == 3
						or player.dancesel == 3
							player.mo.state = S_PLAY_CLUBPENG
						elseif player.randdance == 4
						or player.dancesel == 4
							player.mo.state = S_PLAY_HDANCE
						elseif player.randdance == 5
						or player.dancesel == 5
							player.mo.state = S_PLAY_DHELP
						elseif player.randdance == 6
						or player.dancesel == 6
							player.mo.state = S_PLAY_SPOOKDANCE
						elseif player.dancesel == 7
							player.mo.state = S_FRANK_TPOSE
						elseif player.dancesel == 8
							player.mo.state = S_PLAY_FRCHAIR1
						elseif player.dancesel == 9 or player.dancesel == 12
							player.mo.state = S_PLAY_2POINT1
						elseif player.randdance == 7
						or player.dancesel == 10
							player.mo.state = S_PLAY_BANANA
						elseif player.randdance == 8
						or player.dancesel == 11
							player.mo.state = S_FRANK_BREAKD
						elseif player.dancesel == 13
							player.mo.state = S_FRANK_FAVFAVFAVFAV
						end
						player.frstartdnc = 1 
					end
					
					//sfx (with a special toggle feature) 
					if player.frdncesfx == 0
					and not P_PlayerInPain(player)
						if player.mo.state == S_PLAY_JEVIL
							S_StartSound(player.mo, sfx_frlaf1)
						elseif player.mo.state == S_PLAY_DSPIN
							S_StartSound(player.mo, sfx_frspn1)
						elseif player.mo.state == S_PLAY_CLUBPENG
						or player.mo.state == S_PLAY_FRCHAIR1
							S_StartSound(player.mo, sfx_frstmp)
						elseif player.mo.state == S_PLAY_HDANCE
						or player.mo.state == S_FRANK_TPOSE
							S_StartSound(player.mo, sfx_frhorn)
						elseif player.mo.state == S_PLAY_DHELP
							S_StartSound(player.mo, sfx_frac)
						elseif player.mo.state == S_PLAY_SPOOKDANCE
							S_StartSound(player.mo, sfx_frspok)
						elseif player.mo.state == S_PLAY_2POINT1
							if player.dancesel == 12
								S_StartSound(player.mo, sfx_shutup)
							else S_StartSound(player.mo, sfx_thok) end
						elseif player.mo.state == S_PLAY_BANANA
							S_StartSound(player.mo, sfx_frpbnj)
						elseif player.mo.state == S_FRANK_BREAKD
							S_StartSound(player.mo, sfx_fbstrt)
						elseif player.mo.state == S_FRANK_FAVFAVFAVFAV
							S_StartSound(player.mo, sfx_fdswap)
						end
						player.frdncesfx = 1
					end
					
					//music (cant play when inv. or super/hyper)
					if player.startdncsong == 0
					and not (S_MusicName(player) == "_SHOES" or S_MusicName(player) == "_INV" or S_MusicName(player) == "_MINV")
						if player.mo.state == S_PLAY_JEVIL
							P_PlayJingleMusic(player, "FRTWR", nil, true, JT_OTHER)		
						elseif player.mo.state == S_PLAY_DSPIN
							P_PlayJingleMusic(player, "FRSPIN", nil, true, JT_OTHER)
						elseif player.mo.state == S_PLAY_CLUBPENG
							P_PlayJingleMusic(player, "FRICE", nil, true, JT_OTHER)
						elseif player.mo.state == S_PLAY_HDANCE
							P_PlayJingleMusic(player, "FRHDNC", nil, true, JT_OTHER)
						elseif player.mo.state == S_PLAY_DHELP
						or player.mo.state == S_PLAY_FRCHAIR1
							P_PlayJingleMusic(player, "FRNATH", nil, true, JT_OTHER)
						elseif player.mo.state == S_PLAY_SPOOKDANCE
							P_PlayJingleMusic(player, "FRSPOK", nil, true, JT_OTHER)
						elseif player.mo.state == S_FRANK_TPOSE
							if srb2p
								P_PlayJingleMusic(player, "FRHDNC", nil, true, JT_OTHER)
							else
								P_PlayJingleMusic(player, "_RECAT", nil, true, JT_OTHER)
							end
						elseif player.mo.state == S_PLAY_2POINT1
							if srb2p
								P_PlayJingleMusic(player, "FRICE", nil, true, JT_OTHER)
							else
								P_PlayJingleMusic(player, "VSALT", nil, true, JT_OTHER)
							end
						elseif player.mo.state == S_PLAY_BANANA
							P_PlayJingleMusic(player, "FRPBNJ", nil, true, JT_OTHER)
						elseif player.mo.state == S_FRANK_BREAKD
							P_PlayJingleMusic(player, "FRBREK", nil, true, JT_OTHER)
						elseif player.mo.state == S_FRANK_FAVFAVFAVFAV
							P_PlayJingleMusic(player, "FRBREK", nil, true, JT_OTHER)
						end
						player.startdncsong = 1
					end
					
					-- confetti!!!!!!
					if player.spawnnote == 0 and not P_PlayerInPain(player)
						for i = 0,11 
							local confetti = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-4,6)*FRACUNIT,P_RandomRange(-4,6)*FRACUNIT,player.mo.height, MT_THOK)
							confetti.state = S_FAD_FETTI
							if confetti.valid
								confetti.frame = P_RandomRange(0,2)
								if P_RandomRange(0,4) == 1 
									confetti.color = player.mo.color
								else confetti.color = P_RandomKey(#skincolors-1)+1 end
								P_SetObjectMomZ(confetti, P_RandomRange(5,8)*FRACUNIT, false)
								confetti.angle = FixedAngle(P_RandomRange(0,359)*FRACUNIT)
								P_Thrust(confetti, confetti.angle, P_RandomRange(1,4)*player.mo.scale)
								confetti.fuse = 2*TICRATE
								confetti.momx = $ + (player.mo.momx/3)
								confetti.momy = $ + (player.mo.momy/3)
							end
						end
						
						if player.mo.state == S_FRANK_FAVFAVFAVFAV then P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FADS) end
						
						for i = 0,1
							local mo = P_SpawnMobjFromMobj(player.mo, 0,0,player.mo.height/2, MT_HUGGERTSSTARPART)
							mo.color = SKINCOLOR_SUNFLOWER
							mo.scale = $*2
							if i == 0
								mo.angle = player.mo.angle + ANGLE_90
							else mo.angle = player.mo.angle - ANGLE_90 end
							P_SetObjectMomZ(mo, P_RandomRange(-2,3)*FRACUNIT)
							P_Thrust(mo, mo.angle, P_RandomRange(4,5)*player.mo.scale)
							mo.momx = $ + player.mo.momx
							mo.momy = $ + player.mo.momy
						end
						
						//just to be sure,
						if player.parrycooldown == 0 then player.parrytimer = TICRATE/2 end
						local hURtbox = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FRANK_PARRYBOX)
						hURtbox.target = player.mo
						hURtbox.scale = player.mo.scale
						player.spawnnote = 1
					end
				end
			end
			if player.powers[pw_carry] == CR_MACESPIN
			or (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
				player.mo.state = S_PLAY_ROLL
				player.frankgroovin = false
				if not (S_MusicName(player) == "_SHOES" or S_MusicName(player) == "_INV" or S_MusicName(player) == "_MINV") then P_RestoreMusic(player) end
			end
			
			if player.panim == PA_WALK or player.panim == PA_RUN and not (player.pflags & PF_FULLSTASIS) and not (player.mo.eflags & MFE_SPRUNG) 
				player.frankgroovin = false 
				P_RestoreMusic(player)
			end
		elseif P_IsObjectOnGround(player.mo)
		and player.mo.state != S_PLAY_ROLL and not player.mo.state != S_PLAY_SPINDASH
		and player.flagpushfrank
			player.frankgroovin = true
		end
		
		if player.danceparry == nil then player.danceparry = false end
		if player.danceparry -- parry effects
			player.danceparry = false
			      
			if S_SoundPlaying(player.mo, sfx_frlaf1) then S_StopSoundByID(player.mo, sfx_frlaf1) end
			if S_SoundPlaying(player.mo, sfx_frspn1) then S_StopSoundByID(player.mo, sfx_frspn1) end
			if S_SoundPlaying(player.mo, sfx_frstmp) then S_StopSoundByID(player.mo, sfx_frstmp) end
			if S_SoundPlaying(player.mo, sfx_frhorn) then S_StopSoundByID(player.mo, sfx_frhorn) end
			if S_SoundPlaying(player.mo, sfx_frac) then S_StopSoundByID(player.mo, sfx_frac) end
			if S_SoundPlaying(player.mo, sfx_frspok) then S_StopSoundByID(player.mo, sfx_frspok) end
			if S_SoundPlaying(player.mo, sfx_thok) then S_StopSoundByID(player.mo, sfx_thok) end
			if S_SoundPlaying(player.mo, sfx_frpbnj) then S_StopSoundByID(player.mo, sfx_frpbnj) end
			if S_SoundPlaying(player.mo, sfx_fbstrt) then S_StopSoundByID(player.mo, sfx_fbstrt) end
			
			S_StartSoundAtVolume(player.mo, sfx_fadpry, 250)
			if P_RandomRange(1, 69) == 1 and player.favfunnytoggle == 1 then S_StartSoundAtVolume(player.mo, sfx_fdpery, 250) end
			player.parrytimer = 0
			if CBW_Battle
				player.parrycooldown = TICRATE + 25
			else
				player.parrycooldown = 0
			end
			if not player.powers[pw_flashing] then player.powers[pw_flashing] = TICRATE + 5 end
			player.frankgroovin = false
			if not (S_MusicName(player) == "_SHOES" or S_MusicName(player) == "_INV" or S_MusicName(player) == "_MINV") then P_RestoreMusic(player) end
			if P_RandomRange(1, 2) == 2
				player.mo.state = S_FRANK_KICK
			else player.mo.state = S_FAV_GUARD end
			player.speed = 0
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = player.mo.scale*5
			P_InstaThrust(player.mo, player.mo.angle, -2*player.mo.scale)
			player.mo.color = player.skincolor
			player.mo.colorized = false
			
			local fx = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FADS)
			fx.frame = FF_FULLBRIGHT
			fx.color = player.skincolor
			fx.colorized = true
			fx.destscale = $ + $/2 
			fx.scalespeed = FRACUNIT/10
			fx.blendmode = AST_ADD
		end
		
	else
		if player.frankgroovin
			if (player.mo.state == S_FRANK_FAVFAVFAVFAV or player.mo.state == S_FRANK_BREAKD or player.mo.state == S_PLAY_BANANA or player.mo.state == S_PLAY_2POINT1 or player.mo.state == S_PLAY_FRCHAIR1 or player.mo.state == S_PLAY_FRCHAIR2 or player.mo.state == S_PLAY_CLUBPENG2 or player.mo.state == S_FRANK_TPOSE or player.mo.state == S_PLAY_JEVIL or player.mo.state == S_PLAY_DSPIN or player.mo.state == S_PLAY_CLUBPENG or player.mo.state == S_PLAY_HDANCE or player.mo.state == S_PLAY_DHELP or player.mo.state == S_PLAY_SPOOKDANCE)
				player.mo.state = S_PLAY_STND
			end
			player.frankgroovin = false
			if not (S_MusicName(player) == "_SHOES" or S_MusicName(player) == "_INV" or S_MusicName(player) == "_MINV") then P_RestoreMusic(player) end
			if player.mo.skin != "dummie"
				player.parrytimer = nil
				player.parrycooldown = nil
			end
		end
	end
end)

addHook("MobjThinker", function(thebox)
	if (thebox.target) and thebox.target.player and thebox.target.player.parrytimer != 0
		A_CapeChase(thebox, 5*FRACUNIT,0)
	else
		pcall(P_RemoveMobj, thebox)
	end
end, MT_FRANK_PARRYBOX)

addHook("MobjCollide", function(mo, inflictor)
	if inflictor.valid
	and ((inflictor.flags & MF_ENEMY) or (inflictor.flags & MF_MISSILE) or (inflictor.type == MT_UNIBALL) or (inflictor.type == MT_ENERGYBALL) or (inflictor.type == MT_GOOP) or (inflictor.type == MT_EGGMOBILE_BALL) or (inflictor.type == MT_HAMMER)) and (inflictor.type != MT_LASER)
	and not (inflictor.z > mo.z+mo.height) and not (mo.z > inflictor.z+inflictor.height)
	and (mo.target) and not (inflictor.target and (inflictor.target == mo.target))
	and not P_PlayerInPain(mo.target.player)
		
		if inflictor.favtennissounds != nil and inflictor.favtennissounds == true -- welcome to Tennis.......
			local tennis = P_RandomRange(0,3)
			if tennis == 0
				S_StartSound(inflictor, sfx_favte1)
			elseif tennis == 1
				S_StartSound(inflictor, sfx_favte2)
			elseif tennis == 2
				S_StartSound(inflictor, sfx_favte3)
			elseif tennis == 3
				S_StartSound(inflictor, sfx_favte4)
			end
		end
		
		if (inflictor.flags & MF_ENEMY)
			P_DamageMobj(inflictor, mo, mo.target, 1, DMG_NUKE) -- it's funny trust me
		else
			inflictor.color = mo.target.player.skincolor
			inflictor.momx = -inflictor.momx
			inflictor.momy = -inflictor.momy
			inflictor.momz = -inflictor.momz
			inflictor.flags = $|MF_MISSILE
			inflictor.tracer = ($ and $ == mo.target and inflictor.target) or $
			inflictor.target = mo.target
			inflictor.angle = $ + ANGLE_180
			if inflictor.favtennissounds == nil then inflictor.favtennissounds = true end
		end
		mo.target.player.mo.angle = R_PointToAngle2(mo.target.player.mo.x, mo.target.player.mo.y, inflictor.x, inflictor.y)
		mo.target.player.danceparry = true
	end
	
	return false
end, MT_FRANK_PARRYBOX)

addHook("MobjMoveCollide", function(mo, inflictor)
	if (mo.target) and (mo.target.valid) and inflictor.valid and not (inflictor.z > mo.z+mo.height) and not (mo.z > inflictor.z+inflictor.height)
	and not P_PlayerInPain(mo.target.player)
		if (((inflictor.flags & MF_SHOOTABLE) and not (inflictor.player)) or (inflictor.type == MT_PLAYER and (G_RingSlingerGametype() or CBW_Battle and CBW_Battle.BattleGametype() or not (gametyperules & (GTR_FRIENDLY))) and not (inflictor == mo.target) and not (inflictor.player.powers[pw_flashing]))) and not (inflictor.flags2 & MF2_FRET)
		and not ((mo.target.player.bot) and (inflictor.flags & MF_MONITOR))
			if inflictor.player and CBW_Battle and inflictor.player.battle_atk == 0 return end
			if CBW_Battle and CBW_Battle.BattleGametype() and inflictor.player and not CBW_Battle.MyTeam(mo.target.player,inflictor.player) and not (inflictor == mo.target) and not (inflictor.player.powers[pw_flashing]) and not (inflictor.flags2 & MF2_FRET) and not ((mo.target.player.bot) and (inflictor.flags & MF_MONITOR))
			and not (inflictor.player.tumble and inflictor.player.tumble > 0)
				CBW_Battle.DoPlayerTumble(inflictor.player, 40, mo.angle, 3*inflictor.player.mo.scale, true)
				P_SetObjectMomZ(inflictor.player.mo, 8*FRACUNIT/CBW_Battle.WaterFactor(inflictor.player.mo))
			else
				if (CBW_Battle and CBW_Battle.BattleGametype() and inflictor.player and inflictor.player.tumble and inflictor.player.tumble > 0) return end
				P_DamageMobj(inflictor, mo, mo.target, 1, DMG_NUKE) -- it's funny trust me
			end
			mo.target.player.danceparry = true
			
		end
	end
	return false
end, MT_FRANK_PARRYBOX)