if not srb2p return end

VFX_freeslotC("huggert")
charStats["huggert"] = {

		name = "Huggert",		
		basehp = 100,
		basesp = 40,
		persona = "huggert",
		melee_natk = "huggert_atk1",
		melee_satk = "god hand",
		atk = 30,	
		acc = 85,	
		crit = 3,	
		
		wep = "crescent sneakers",
		weptype = WPT_GENERICRANGED|WPT_SHOES|WPT_HEELS,
		
		supercolor_start = SKINCOLOR_SUPER_HUGGERTS_1,
		supermusic = "FADSPR",

		anim_stand = 		{SPR_PLAY, A, 15, "SPR2_STND"},
		anim_stand_hurt =	{SPR_PLAY, A, B, C, B, 15, "SPR2_WALK"},
		anim_stand_bored =	{SPR_PLAY, A, B, C, D, E, F, A, B, C, D, E, F, A, 25, "SPR2_WAIT"},
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_TALA"},
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},
		anim_atk =			{SPR_PLAY, A, B, C, D, E, 1, "SPR2_ROLL"},
		anim_aoa_end =		{SPR_PLAY, G, 2, "SPR2_TRNS"},
		anim_hurt =			{SPR_PLAY, A, 20, "SPR2_PAIN"},	
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_SHIT"},
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_SHIT"},	
		anim_getup =		{SPR_PLAY, A, 5, "SPR2_SPNG"},	
		anim_death =		{SPR_PLAY, A, B, 3, "SPR2_DEAD"},	
		anim_revive =		{SPR_PLAY, A, B, C, D, E, F, G, G, G, G, G, G, G, G, G, G, G, 2, "SPR2_TRNS"},		-- gets revived
		anim_evoker =		{SPR_PLAY, A, B, C, D, E, 5, "SPR2_ROLL"},
		anim_evoker_shoot =	{SPR_PLAY, A, B, C, D, E, F, C, D, E, F, G, 2, "SPR2_TRNS"},
		anim_special1 = {SPR_PLAY, A, B, C, D, E, 1, "SPR2_ROLL"},
		anim_special2 = {SPR_PLAY, A, B, C, D, E, F, G, H, I, A, B, C, D, E, F, G, H, I, 3, "SPR2_HHUG"}, --hug!
		anim_special3 = {SPR_PLAY, A, B, 2, "SPR2_FALL"},

		anim_stand_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},
		anim_stand_hurt_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},
		anim_stand_bored_super = 	{SPR_PLAY, A, B, C, D, E, F, A, B, C, D, E, F, A, 10, "SPR2_WAIT"},
		anim_run_super = 	{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},
		anim_evoker_super =		{SPR_PLAY, A, B, C, D, 6, "SPR2_ROLL"},
		anim_evoker_shoot_super =	{SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},


		vfx_summon = {"sfx_hgsmk"},
        vfx_skill = {"sfx_duskil"},
        vfx_item = {"sfx_hgsbn"},
        vfx_hurt = {"sfx_duhrt"},
        vfx_hurtx = {"sfx_duxhrt"},	
        vfx_die = {"sfx_duhrt"},
        vfx_heal = {"sfx_hughug"},
        vfx_healself = {"sfx_hughug"},
        vfx_kill = {"sfx_dulup"}, 
        vfx_1more = {"sfx_hughug"},	 
        vfx_crit = {"sfx_ducrit"},
        vfx_aoaask = {"sfx_dumask"},
        vfx_aoado = {"sfx_hgstb"},
        vfx_aoarelent = {"sfx_hsqsh"},	
        vfx_miss = {"sfx_hsqsh"},
        vfx_dodge = {"sfx_hgspf"},	
        vfx_win = {"sfx_duwin"},
        vfx_levelup = {"sfx_dulup"}, 

		icon = "ICO_HGRT",
		hudbust = "HGT_H",
		hudaoa = "H_HGTAOA",
		hudcutin = "HGRT_A",
		hudspr = "HGRT",
		aoa_quote = "Let's show these folks \na good time!   ^w^",
		
			
 
		tip = "Focusing on the winter aesthetic, Huggert mainly learns Ice attacks. Instead of freezing enemies, Huggert can make them fall asleep! Huggert will slowly become stronger against snoozing enemies, so snooze until you lose!",
}		     

personaList["huggert"] = {
		-- GENERAL
		name = "huggert",
		arcana = ARCANA_SUN, 
		sprite = nil,
		startframe = nil,
 
		anim_idle =     nil,
		anim_atk =      nil,
 
		strength = 6,
		magic = 11,
		endurance = 9,
		luck = 10,
		agility = 3,
 
		weak = ATK_ELEC|ATK_CURSE, 
		block = ATK_ICE,
		
//		stab = ATK_,
 
		//big thank you to Zoraxura for helping with huggert's ability list! I know nothing about proper balance LOL
		skills = {
					
					{"eepy cold", 1}, 
					
					{"power nap", 4},
					{"dia", 5}, 
					{"gry", 8},
					{"sleepy seeker 1", 10}, 
					{"ice break", 13}, 
					{"recarm", 17},
						
					{"eepy frost", 23, "eepy cold"},
					{"dekunda", 25},
					{"dormancy nap", 29, "power nap"},
					{"diarama", 30, "dia"},
					{"gryva", 36, "gry"},
											
					{"sleepy seeker 2", 40, "sleepy seeker 1"},
					{"samarecarm", 45, "recarm"},
					{"hibernation nap", 50, "dormancy nap"},
					
					{"eepy snowfield", 53, "eepy frost"},
					{"diarahan", 58, "diarama"},
					{"grydyne", 63, "gryva"},
					{"insomni nap", 72, "hibernation nap"},
					{"sleepy seeker 3", 80, "sleepy seeker 2"},
					{"eepy tundra", 84, "eepy snowfield"},
					
				},
}
	
attackDefs["huggert_atk1"] = {
		name = "Star shoot",
		type = ATK_PIERCE,
		power = 50,
		accuracy = 100,
		critical = 5,
		target = TGT_ENEMY,
		costtype = CST_HP,
		cost = 0,
		desc = "Shoot stars towards\nthe enemy.",
		anim_norepel = true,
		physical = true,
		anim = function(mo, targets, hittargets, timer)
					local target = targets[1]
					local atarget = hittargets[1]
					
					if timer == 1
						ANIM_set(mo, mo.anim_stand_bored, true)
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
						
						playSound(mo.battlen, sfx_hgsmk)
					end
					
					if timer == 1
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, mo.x, mo.y, mo.z + 10*FRACUNIT, FRACUNIT)
					elseif timer == 6
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, mo.x, mo.y, mo.z + 10*FRACUNIT, 2*FRACUNIT)
					elseif timer == 11
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, mo.x, mo.y, mo.z + 10*FRACUNIT, 4*FRACUNIT)
					elseif timer == 21
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, mo.x, mo.y, mo.z + 10*FRACUNIT, 5*FRACUNIT)
					end
					
					if timer < TICRATE and timer != 0
						if (timer % 2 == 0)
							for i = 0,(timer/18)
								local st = P_SpawnMobjFromMobj(mo, P_RandomRange(-65, 65)*mo.scale, P_RandomRange(-65, 65)*mo.scale, P_RandomRange(-35, 50)*mo.scale, MT_THOK)
								st.state = S_HUGSTARP1
								st.blendmode = AST_ADD
								st.scale = $*P_RandomRange(1, 4)/P_RandomRange(2, 4)
								st.destscale = 0
								st.scalespeed = FRACUNIT/23 
								st.color = ColorOpposite(mo.color)
								if (leveltime % 4 == 0) then st.color = P_RandomRange(71, 105) end // a full on rainbow effect that grabs ALL colors!!
							end
						end
					end
					
					if timer == TICRATE*3/2 - 10
						ANIM_set(mo, mo.anim_special1, true)
						local cx = target.x + 168*cos(target.angle + ANG1*20)
						local cy = target.y + 168*sin(target.angle + ANG1*20)
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 30*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
						atarget.angle = R_PointToAngle2(atarget.x, atarget.y, mo.x, mo.y)
					end
					
					if timer >= TICRATE and timer % 4 == 0 and timer < TICRATE*2
							
						local star = P_SpawnMobj(P_RandomRange(-8, 8)*mo.scale+mo.x, P_RandomRange(-8, 8)*mo.scale+mo.y, P_RandomRange(-8, 8)*mo.scale+mo.z, MT_THOK)
						star.state = S_HUGGERTBULLET
						star.rollangle = FixedAngle(P_RandomRange(0, 255)*FRACUNIT)
						star.angle = mo.angle
						star.color = mo.color
						P_InstaThrust(star, star.angle, 25*FRACUNIT)
						S_StartSound(mo, sfx_hgstb)
						star.fuse = 3*TICRATE
					end
					
					if timer == TICRATE*3/2
						damageObject(atarget)
						playSound(mo.battlen, sfx_hit2)
						P_InstaThrust(atarget, atarget.angle, -8*FRACUNIT)
						atarget.momz = 6*FRACUNIT
						ANIM_set(mo, mo.anim_stand, true)
					elseif timer == TICRATE*3
						return true
					end
		
				end,
	}
	
attackDefs["eepy cold"] = {//I'm sure you can come up with better names
	name = "Cold Night",
	type = ATK_ICE,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 6,//Costs a little more
	status = COND_SLEEP,
	statuschance = 10,//Coz of a higher chance
	desc = "Light Ice dmg to one enemy.\nMay inflict sleep.",
	target = TGT_ENEMY,
	anim = attackDefs["bufu"].anim,//This just makes it play the anim for bufu, since these are basically placeholderish
}

attackDefs["eepy frost"] = {
	name = "Frosty Night",
	type = ATK_ICE,
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 12,
	status = COND_SLEEP,
	statuschance = 10,
	desc = "Moderate Ice dmg to one enemy.\nMay inflict sleep.",
	target = TGT_ENEMY,
	anim = attackDefs["bufula"].anim,
}

attackDefs["eepy snowfield"] = {
	name = "Blizzard Night",
	type = ATK_ICE,
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 12,
	status = COND_SLEEP,
	statuschance = 10,
	desc = "Heavy Ice dmg to one enemy.\nMay inflict sleep.",
	target = TGT_ENEMY,
	anim = attackDefs["bufudyne"].anim,
}

attackDefs["eepy tundra"] = {
	name = "Tundra Night",
	type = ATK_ICE,
	power = 650,
	accuracy = 100,
	costtype = CST_SP,
	cost = 48,
	status = COND_SLEEP,
	statuschance = 20,
	desc = "Severe Ice dmg to one enemy.\nHigh chance of sleep.",
	target = TGT_ENEMY,
	anim = attackDefs["niflheim"].anim,
}

attackDefs["sleepy seeker 1"] = {
	name = "Snooze Button",
	type = ATK_PASSIVE,
	status = COND_SLEEP,
	desc = "Increase damage by 20% when\nattacking enemies inflicted\nwith sleep.",
	passive = PSV_SLAYER,
	power = 20,
}

attackDefs["sleepy seeker 2"] = {
	name = "Snooze Button DX",
	type = ATK_PASSIVE,
	status = COND_SLEEP,
	desc = "Increase damage by 33% when\nattacking enemies inflicted\nwith sleep.",
	passive = PSV_SLAYER,
	power = 33,
}

attackDefs["sleepy seeker 3"] = {
	name = "Snooze Button DX+",
	type = ATK_PASSIVE,
	status = COND_SLEEP,
	desc = "Increase damage by 50% when\nattacking enemies inflicted\nwith sleep.",
	passive = PSV_SLAYER,
	power = 50,
}

attackDefs["power nap"] = {
	name = "Power Nap",
	type = ATK_SUPPORT,
	power = 0,
	accuracy = 15,
	statuschance = 15,
	status = COND_SLEEP,
	costtype = CST_SP,
	luckbased = true,	-- use luck instead of agility
	cost = 3,
	desc = "Okay chance of inflicting \nSleep on 1 enemy.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				
				local tpdestx = target.x - 35*cos(target.angle + ANGLE_90)
				local tpdesty = target.y - 35*sin(target.angle + ANGLE_90)
				
				if timer == 1
					local cx = target.x + 168*cos(target.angle + ANG1*20)
					local cy = target.y + 168*sin(target.angle + ANG1*20)
					CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
					CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
					P_TeleportMove(mo, tpdestx, tpdesty, target.z + FRACUNIT*300)
					mo.landed = false
					ANIM_set(mo, mo.anim_special3, true)
				end
				
				if P_IsObjectOnGround(mo) and not mo.landed
					ANIM_set(mo, mo.anim_special2, true)
					playSound(mo.battlen, sfx_hughug)
					mo.landed = true
				end

				if mo.landed and timer <= 40
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.state = S_CDUST1
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_SILVER
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT*3/2
				end

				if timer == 45
					damageObject(target)
				elseif timer == 65
					mo.landed = false
					return true
				end
		end,
}

attackDefs["dormancy nap"] = {
	name = "Dormancy Nap",
	type = ATK_SUPPORT,
	power = 0,
	accuracy = 35,
	statuschance = 35,
	status = COND_SLEEP,
	costtype = CST_SP,
	luckbased = true,	-- use luck instead of agility
	cost = 4,
	desc = "Moderate chance of inflicting \nSleep on 1 enemy.",
	target = TGT_ENEMY,
	anim = attackDefs["power nap"].anim,
}

attackDefs["hibernation nap"] = {
	name = "Hibernation Nap",
	type = ATK_SUPPORT,
	power = 0,
	accuracy = 45,
	statuschance = 45,
	status = COND_SLEEP,
	costtype = CST_SP,
	luckbased = true,	-- use luck instead of agility
	cost = 10,
	desc = "High chance of inflicting \nSleep on 1 enemy.",
	target = TGT_ENEMY,
	anim = attackDefs["power nap"].anim,
}

attackDefs["insomni nap"] = {
	name = "Insomni- Nap",
	type = ATK_SUPPORT,
	power = 0,
	accuracy = 75,
	statuschance = 75,
	status = COND_SLEEP,
	costtype = CST_SP,
	luckbased = true,	-- use luck instead of agility
	cost = 10,
	desc = "A 3/4th chance of inflicting \nSleep on 1 enemy.",
	target = TGT_ENEMY,
	anim = attackDefs["power nap"].anim,
}

DNG_Abilities["huggert"] = {

	jfunc = 	function(p)
					local mo = p.mo
					p.pflags = $ & ~PF_JUMPED
					mo.state = S_HUGGERTFLY
					p.huggertsHoverTimeForSRB2PShenanigans = 4 + TICRATE
					p.huggertsHoverTimeForSRB2PBoolean = false
					
					for i = 1, 6
						local d = P_SpawnMobjFromMobj(mo, 0,0,0, MT_HGTCLOUDS)
						d.scale = $*(3/2)
						d.angle = i*ANG60 + mo.angle
						P_Thrust(d, d.angle, 5*mo.scale)
						d.destscale = $/4
						d.scalespeed = mo.scale/40
						d.momx = $+mo.momx
						d.momy = $+mo.momy
						d.momz = mo.momz
					end
					S_StartSound(mo, sfx_s227)
					S_StartSound(mo, sfx_s3k4b)
					
				end,

	func =		function(p)
					local mo = p.mo

					if mo.p_abl
						if (p.cmd.buttons & BT_JUMP)
							if mo.state != S_HUGGERTFLY then mo.state = S_HUGGERTFLY end
							if p.huggertsHoverTimeForSRB2PShenanigans >= 1
								if p.mo.momz/P_MobjFlip(mo) < 5*mo.scale
									P_SetObjectMomZ(mo, 1*FRACUNIT, true)
								else
									P_SetObjectMomZ(mo, 5*FRACUNIT)
									p.huggertsHoverTimeForSRB2PBoolean = true
								end
								if p.huggertsHoverTimeForSRB2PBoolean then p.huggertsHoverTimeForSRB2PShenanigans = $-1 end
							else
								P_SetObjectMomZ(mo, gravity*1/4, true)
							end
							
							if (leveltime % 8 == 0)
								for i = 0,P_RandomRange(1, 2)
									p.randomLOL = P_RandomRange(0, 5)
									local spaceparticle = P_SpawnMobjFromMobj(mo, (P_RandomRange(-32,32)*mo.scale),(P_RandomRange(-32,32)*mo.scale),(P_RandomRange(-30,-5)*mo.scale), MT_HGTFLY)
									if p.randomLOL <= 1
										if p.randomLOL == 0 
											spaceparticle.color = mo.color
										else spaceparticle.color = ColorOpposite(mo.color) end
										spaceparticle.colorized = true
									end
									spaceparticle.scale = $*(P_RandomRange(1, 3)/2)
									spaceparticle.frame = P_RandomRange(0, 6)
									spaceparticle.momx = P_RandomRange(-1, 1)*mo.scale
									spaceparticle.momy = P_RandomRange(-1, 1)*mo.scale
									spaceparticle.destscale = 0
									spaceparticle.scalespeed = mo.scale/40
								end
							end
							if (leveltime % 4 == 0)
								for i = 0, 2
									local clounds = P_SpawnMobjFromMobj(mo, (P_RandomRange(-32,32)*mo.scale),(P_RandomRange(-32,32)*mo.scale),(P_RandomRange(-30,-5)*mo.scale), MT_HGTFLY)
									clounds.frame = P_RandomRange(7, 16)|TR_TRANS20
									clounds.momx = P_RandomRange(-1, 1)*mo.scale
									clounds.momy = P_RandomRange(-1, 1)*mo.scale
									clounds.scale = $*(P_RandomRange(3, 4)/2)
									clounds.destscale = 0
									clounds.scalespeed = mo.scale/26
								end
							end 
							
							
							if P_IsObjectOnGround(mo)
								mo.p_abl = false
								mo.state = S_PLAY_WALK
								for i = 1, 6
									local d = P_SpawnMobjFromMobj(mo, 0,0,0, MT_HGTCLOUDS)
									d.scale = $*(3/2)
									d.angle = i*ANG60 + mo.angle
									P_Thrust(d, d.angle, 5*mo.scale)
									d.destscale = $/5
									d.scalespeed = mo.scale/40
									d.momx = $+mo.momx
									d.momy = $+mo.momy
									d.momz = mo.momz
								end
								S_StartSound(mo, sfx_s3k6d)
							end
						else
							mo.p_abl = false
							mo.state = S_PLAY_FALL
							for i = 1, 6
								local d = P_SpawnMobjFromMobj(mo, 0,0,0, MT_HGTCLOUDS)
								d.scale = $*(3/2)
								d.angle = i*ANG60 + mo.angle
								P_Thrust(d, d.angle, 5*mo.scale)
								d.destscale = $/5
								d.scalespeed = mo.scale/40
								d.momx = $+mo.momx
								d.momy = $+mo.momy
								d.momz = mo.momz
							end
							S_StartSound(mo, sfx_s3k6d)
						end
					end
				end,

}