local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(ScriptLoaded)
		and CBW_Battle 
		then
		ScriptLoaded = true 
		local B = CBW_Battle

		local DreamStars = function(mo,doaction)
			local player = mo.player
			player.actiontext = "Dream Star"
			player.actionrings = 12
			
			player.action2text = nil 
			player.action2rings = 0 
			
			
			if not(B.CanDoAction(player)) 
				player.actionstate = 0 
				return end	

			if player.actionstate == 0 
			and not (player.pflags & PF_STARTDASH)
			and not (player.pflags & PF_THOKKED)  
				if (doaction == 1) then 
					player.actionstate = 1  
					player.actiontime = 0
					B.PayRings(player) 
					S_StartSound(mo,sfx_s3k3c)
					S_StartSound(player.mo, sfx_hgsmk)
					S_StartSound(player.mo, sfx_vwre)
				end
			end
			
			if player.actionstate == 1 --windup
				player.actiontime = $+1
				player.actiontext = "Charging..."
				player.lockmove = true
				
				for i = 0,(player.actiontime/10)
					local st = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-65, 65)*player.mo.scale, P_RandomRange(-65, 65)*player.mo.scale, P_RandomRange(-35, 50)*player.mo.scale, MT_HUGGERTSSTARPART)
					st.target = player.mo
					st.blendmode = AST_ADD
					st.scale = $*P_RandomRange(1, 4)/P_RandomRange(2, 4)
					st.destscale = 0
					st.scalespeed = FRACUNIT/23 
					st.color = ColorOpposite(player.mo.color)
					if (leveltime % 4 == 0) then st.color = P_RandomRange(71, 105) end // a full on rainbow effect that grabs ALL colors!!
				end
				
				if player.actiontime <= 2 and player.actiontime > 0
					player.mo.state = S_PLAY_STND
					player.mo.sprite2 = SPR2_TRNS
					player.mo.frame = 0
				end
				if player.actiontime >= 3 and player.actiontime < 1*TICRATE - 15
					player.mo.state = S_PLAY_STND
					player.mo.sprite2 = SPR2_TRNS
					player.mo.frame = 1
				end
				if player.actiontime >= 1*TICRATE - 15 and player.actiontime < 1*TICRATE - 10
					player.mo.state = S_PLAY_STND
					player.mo.sprite2 = SPR2_TRNS
					player.mo.frame = 5
				end
				if player.actiontime >= 1*TICRATE - 10
					player.mo.state = S_PLAY_STND
					player.mo.sprite2 = SPR2_TRNS
					player.mo.frame = 6
				end
				
				if player.actiontime == 1*TICRATE + 15
					player.mo.state = S_PLAY_WALK
					player.actionstate = 2
					S_StartSound(player.mo, sfx_hamrc)
				end
				
			elseif player.actionstate == 2 --Holding the charge
				player.lockmove = false
				if leveltime % 3 == 0
					for i = 0,1
						local backtrail = P_SpawnGhostMobj(player.mo)
						backtrail.color = player.skincolor
						backtrail.colorized = true
						backtrail.fuse = 9
						backtrail.momx = P_RandomRange(-6, 6)*player.mo.scale + player.mo.momx
						backtrail.momy = P_RandomRange(-6, 6)*player.mo.scale + player.mo.momy
						backtrail.momz = P_RandomRange(-6, 6)*player.mo.scale + player.mo.momz
					end
					for i = 0,3
						local st = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-65, 65)*player.mo.scale, P_RandomRange(-65, 65)*player.mo.scale, P_RandomRange(-35, 50)*player.mo.scale, MT_HUGGERTSSTARPART)
						st.blendmode = AST_ADD
						st.scale = $*P_RandomRange(1, 4)/P_RandomRange(2, 4)
						st.destscale = 0
						st.scalespeed = FRACUNIT/23 
						st.color = player.skincolor
					end
				end
				
				if leveltime % TICRATE == 0 then 
					S_StartSound(player.mo,sfx_s3k5c) 
					local backtrail = P_SpawnGhostMobj(player.mo)
					backtrail.color = player.skincolor
					backtrail.colorized = true
					backtrail.fuse = 9
					backtrail.destscale = $*3
					backtrail.scalespeed = FRACUNIT/14
					backtrail.blendmode = AST_ADD
				
				end
				player.normalspeed = skins[player.mo.skin].normalspeed/2
				player.actiontext = "FIRE!"
				
				if (doaction == 1) then 
					player.actionstate = 3
					player.actiontime = 0
					S_StartSound(player.mo, sfx_hgsmk)
					S_StartSound(starsm, sfx_cdfm13)
				end
				
			elseif player.actionstate == 3
				player.actiontime = $+1
				B.DrawAimLine(player,player.mo.angle)
				
				if player.actiontime >= TICRATE - 5
					if S_SoundPlaying(player.mo, sfx_hgsmk)
						S_StopSoundByID(player.mo, sfx_hgsmk)
					end
					S_StartSound(player.mo, sfx_s3k81)
					player.lockmove = false
					local bo = P_SpawnMobjFromMobj(player.mo, 0,0, 10*player.mo.scale, MT_HUGGERTBULLET)
					bo.target = player.mo
					bo.angle = player.mo.angle
					bo.hugshield = 0
					bo.color = player.skincolor
		
					bo.radius = 26*player.mo.scale
					bo.height = 45*player.mo.scale
					bo.scale = player.mo.scale + (player.mo.scale/2)
					bo.fuse = 3*TICRATE
					if player.jaspermode then bo.state = S_HUGSTARNORMAL3 end
					bo.starsped = 15*player.mo.scale
					bo.dreamstar = true
					P_InstaThrust(bo, bo.angle, 15*player.mo.scale)
					P_Thrust(player.mo, player.mo.angle, -20*player.mo.scale)
					player.mo.state = S_HUGGERT_FIRE
					
					if player.jaspermode
						S_StartSound(player.mo, sfx_jspr)
					else
						S_StartSound(player.mo, sfx_hgstb)
					end
					player.normalspeed = skins[player.mo.skin].normalspeed
					
					player.actionstate = 0
					player.actiontime = 0
					B.ApplyCooldown(player,12*TICRATE)
				else
					player.mo.state = S_PLAY_STND
					player.mo.sprite2 = SPR2_TRNS
					player.mo.frame = 0
				end
			end
			
			if (P_PlayerInPain(player))
			or not player.mo.health
				player.lockmove = false
				player.actionstate = 0
				player.actiontime = 0
				player.flags = skins[player.mo.skin].flags
				player.normalspeed = skins[player.mo.skin].normalspeed
				B.ApplyCooldown(player,13*TICRATE) -- nerd.
			end
		end
		
		local ExhaustHuggert = function(player) --fine, i'll nerf it >:(
			if player.hugflytime == nil or P_IsObjectOnGround(player.mo) then player.hugflytime = 4*TICRATE end
			if player.mo.state == S_HUGGERTFLY and player.hugflytime > 0 then player.hugflytime = $-1 end
			
			if player.hugflytime < 2*TICRATE and player.hugflytime % 16 == 0 and player.mo.state == S_HUGGERTFLY
				S_StartSound(player.mo, sfx_s1b6)
				P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FRANKSWET)
			end
			
			if player.starcharger > 0 and player.aimdown == false then B.DrawAimLine(player,player.mo.angle) end
			
			if player.hugflytime == 1 or  player.hugflytime == 0
				player.hugjump  = -69
				player.mo.state = S_PLAY_FALL
				return true
			end
			return false
		end
		
		CBW_Battle.SkinVars["huggert"] = {
			flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD,
			weight = 75,
			special = DreamStars,
			func_exhaust = ExhaustHuggert,
			guard_frame = 1,
		}
	end
end)